#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Chars.h"
#include "Print.h"
#include "Knife.h"
#include "VVram.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    PrintS(Vram + VramRowSize * 0 + 16 * VramStep, "SC"); 
    // PrintS(Vram + VramRowSize * 1 + 16 * VramStep, "HI");
    PrintS(Vram + VramRowSize * 1 + 16 * VramStep, "ST");
    PrintByteNumber2(Vram + VramRowSize * 1 + 22 * VramStep, CurrentStage + 1);
    PrintS(Vram + VramRowSize * 2 + 16 * VramStep, "T");
    {
        constexpr ptr<byte> RemainLeft = Vram + VramRowSize * 7 + 17 * VramStep;
        ptr<byte> pVram;
        byte count;
        pVram = RemainLeft;
        for (count = 1; count < RemainCount; ++count) {
            pVram = Put2C(pVram, Char_Man);
        }
    }

    PrintScore();
    PrintTime();
    PrintHeldKnives();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + VramRowSize * 0 + 18 * VramStep, Score);
    PrintC(pVram, '0');

    // pVram = PrintNumber5(Vram + VramRowSize * 7 + 26, HiScore);
    // PrintC(pVram, '0');
}

void PrintTime()
{
    PrintNumber3(Vram + VramRowSize * 2 + 21 * VramStep, StageTime);
}

void PrintHeldKnives()
{
    ptr<byte> pVram;
    byte count, i;

    pVram = Vram + VramRowSize * 6 + 19 * VramStep;
    i = 0;
    count = HeldKnifeCount;
    while (count != 0) {
        pVram = PutU(pVram, Char_Kn_Left);
        ++i;
        --count;
    }
    while (i != 4) {
        pVram = PutU(pVram, Char_Space);
        ++i;
    }
}

void PrintGameOver()
{
    constexpr byte Left = (VVramWidth - 9) / 2;
    PrintS(Vram + VramRowSize * (VramHeight / 4) + Left * VramStep, "GAME OVER");
    PresendVram();
}

void PrintTimeUp() 
{
    constexpr byte Left = (VVramWidth - 6) / 2;
    PrintS(Vram + VramRowSize * (VramHeight / 4) + Left * VramStep, "TIME UP");
    PresendVram();
}

void Title()
{
    ClearScreen(); 
    PrintStatus();
    {
        static const byte[] TitleBytes = {
            //	M
            0x0c, 0x07, 0x07, 0x0b, 
            0x0c, 0x03, 0x03, 0x0f, 
            0x0c, 0x03, 0x03, 0x0f, 
            0x04, 0x01, 0x01, 0x05, 
            //	A
            0x00, 0x0e, 0x0d, 0x02, 
            0x0c, 0x03, 0x00, 0x0f, 
            0x0c, 0x07, 0x05, 0x0f, 
            0x04, 0x01, 0x00, 0x05, 
            //	Z
            0x04, 0x05, 0x0d, 0x07, 
            0x00, 0x08, 0x07, 0x00, 
            0x08, 0x07, 0x00, 0x00, 
            0x04, 0x05, 0x05, 0x05, 
            //	Y
            0x0c, 0x03, 0x0c, 0x03, 
            0x04, 0x0b, 0x0e, 0x01, 
            0x00, 0x0c, 0x03, 0x00, 
            0x00, 0x04, 0x01, 0x00, 
        };
        constexpr byte LogoLength = 4;
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 1;
        p = TitleBytes;
        repeat (LogoLength) {
            repeat (2) {
                repeat (4) {
                    pVram = PutU(pVram, *p);
                    ++p;
                }
                pVram -= 4 * VramStep;
                repeat (4) {
                    pVram = PutL(pVram, *p);
                    ++p;
                }
                pVram += VramRowSize - 4 * VramStep;
            }
            pVram += 4 * VramStep - VramRowSize * 2;
        }
        PrintS(Vram + VramRowSize * 3 + (VVramWidth - 6) * VramStep, "MINI");
    }
    PrintS(Vram + VramRowSize * 5 + (VVramWidth - 14) * VramStep / 2, "PUSH SPACE KEY");
    PrintS(Vram + VramRowSize * 6 + (VVramWidth - 14) * VramStep / 2, "OR RETURN KEY");
    PrintS(Vram + VramRowSize * 7 + (VVramWidth - 12) * VramStep, "INUFUTO 2023");
    // {
    //     byte c;
    //     ptr<byte> pVram;
    //     pVram = Vram;
    //     c = 0;
    //     repeat (0) {
    //         pVram = Put(pVram, c);
    //         ++c;
    //         if ((c & 15) == 0) {
    //             pVram += VramRowSize - 16;
    //         }
    //     }
    // //     // UpdateEnemyChars();
    // //     // SwitchChars();
    // //     // while (true) {
    // //     //     ++EnemyRowLeft;
    // //     //     UpdateEnemyChars();
    // //     //     SwitchChars();
    // //     //     WaitTimer(30);
    // //     // }
    // }
    PresendVram();
}
